--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -2500,8 +2694,11 @@
 	/*
 	 * re-alloc when it has already alloced
 	 */
-	mptsas_dma_addr_destroy(&mpt->m_dma_req_frame_hdl,
-	    &mpt->m_acc_req_frame_hdl);
+	if (mpt->m_dma_flags & MPTSAS_REQ_FRAME) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_req_frame_hdl,
+		    &mpt->m_acc_req_frame_hdl);
+		mpt->m_dma_flags &= ~MPTSAS_REQ_FRAME;
+	}
 
 	/*
 	 * The size of the request frame pool is:
@@ -2539,6 +2736,81 @@
 	 */
 	bzero(mpt->m_req_frame, mem_size);
 
+	mpt->m_dma_flags |= MPTSAS_REQ_FRAME;
+	return (DDI_SUCCESS);
+}
+
+static int
+mptsas_alloc_sense_bufs(mptsas_t *mpt)
+{
+	ddi_dma_attr_t		sense_dma_attrs;
+	caddr_t			memp;
+	ddi_dma_cookie_t	cookie;
+	size_t			mem_size;
+	int			num_extrqsense_bufs;
+
+	/*
+	 * re-alloc when it has already alloced
+	 */
+	if (mpt->m_dma_flags & MPTSAS_REQ_SENSE) {
+		rmfreemap(mpt->m_erqsense_map);
+		mptsas_dma_addr_destroy(&mpt->m_dma_req_sense_hdl,
+		    &mpt->m_acc_req_sense_hdl);
+		mpt->m_dma_flags &= ~MPTSAS_REQ_SENSE;
+	}
+
+	/*
+	 * The size of the request sense pool is:
+	 *   (Number of Request Frames - 2 ) * Request Sense Size +
+	 *   extra memory for extended sense requests.
+	 */
+	mem_size = ((mpt->m_max_requests - 2) * mpt->m_req_sense_size) +
+	    mptsas_extreq_sense_bufsize;
+
+	/*
+	 * set the DMA attributes.  ARQ buffers
+	 * aligned on a 16-byte boundry.
+	 */
+	sense_dma_attrs = mpt->m_msg_dma_attr;
+	sense_dma_attrs.dma_attr_align = 16;
+	sense_dma_attrs.dma_attr_sgllen = 1;
+
+	/*
+	 * allocate the request sense buffer pool.
+	 */
+	if (mptsas_dma_addr_create(mpt, sense_dma_attrs,
+	    &mpt->m_dma_req_sense_hdl, &mpt->m_acc_req_sense_hdl, &memp,
+	    mem_size, &cookie) == FALSE) {
+		return (DDI_FAILURE);
+	}
+
+	/*
+	 * Store the request sense base memory address.  This chip uses this
+	 * address to dma the request sense data.  The second
+	 * address is the address mpt uses to access the data.
+	 * The third is the base for the extended rqsense buffers.
+	 */
+	mpt->m_req_sense_dma_addr = cookie.dmac_laddress;
+	mpt->m_req_sense = memp;
+	memp += (mpt->m_max_requests - 2) * mpt->m_req_sense_size;
+	mpt->m_extreq_sense = memp;
+
+	/*
+	 * The extra memory is divided up into multiples of the base
+	 * buffer size in order to allocate via rmalloc().
+	 * Note that the rmallocmap cannot start at zero!
+	 */
+	num_extrqsense_bufs = mptsas_extreq_sense_bufsize /
+	    mpt->m_req_sense_size;
+	mpt->m_erqsense_map = rmallocmap_wait(num_extrqsense_bufs);
+	rmfree(mpt->m_erqsense_map, num_extrqsense_bufs, 1);
+
+	/*
+	 * Clear the pool.
+	 */
+	bzero(mpt->m_req_sense, mem_size);
+
+	mpt->m_dma_flags |= MPTSAS_REQ_SENSE;
 	return (DDI_SUCCESS);
 }
 
@@ -2553,8 +2825,11 @@
 	/*
 	 * re-alloc when it has already alloced
 	 */
-	mptsas_dma_addr_destroy(&mpt->m_dma_reply_frame_hdl,
-	    &mpt->m_acc_reply_frame_hdl);
+	if (mpt->m_dma_flags & MPTSAS_REPLY_FRAME) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_reply_frame_hdl,
+		    &mpt->m_acc_reply_frame_hdl);
+		mpt->m_dma_flags &= ~MPTSAS_REPLY_FRAME;
+	}
 
 	/*
 	 * The size of the reply frame pool is:
@@ -2591,6 +2866,7 @@
 	 */
 	bzero(mpt->m_reply_frame, mem_size);
 
+	mpt->m_dma_flags |= MPTSAS_REPLY_FRAME;
 	return (DDI_SUCCESS);
 }
 
@@ -2605,8 +2881,11 @@
 	/*
 	 * re-alloc when it has already alloced
 	 */
-	mptsas_dma_addr_destroy(&mpt->m_dma_free_queue_hdl,
-	    &mpt->m_acc_free_queue_hdl);
+	if (mpt->m_dma_flags & MPTSAS_FREE_QUEUE) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_free_queue_hdl,
+		    &mpt->m_acc_free_queue_hdl);
+		mpt->m_dma_flags &= ~MPTSAS_FREE_QUEUE;
+	}
 
 	/*
 	 * The reply free queue size is:
@@ -2646,9 +2925,31 @@
 	 */
 	bzero(mpt->m_free_queue, mem_size);
 
+	mpt->m_dma_flags |= MPTSAS_FREE_QUEUE;
 	return (DDI_SUCCESS);
 }
 
+static void
+mptsas_free_post_queue(mptsas_t *mpt)
+{
+	mptsas_reply_pqueue_t	*rpqp;
+	int			i;
+
+	if (mpt->m_dma_flags & MPTSAS_POST_QUEUE) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_post_queue_hdl,
+		    &mpt->m_acc_post_queue_hdl);
+		rpqp = mpt->m_rep_post_queues;
+		for (i = 0; i < mpt->m_post_reply_qcount; i++) {
+			mutex_destroy(&rpqp->rpq_mutex);
+			rpqp++;
+		}
+		kmem_free(mpt->m_rep_post_queues,
+		    sizeof (mptsas_reply_pqueue_t) *
+		    mpt->m_post_reply_qcount);
+		mpt->m_dma_flags &= ~MPTSAS_POST_QUEUE;
+	}
+}
+
 static int
 mptsas_alloc_post_queue(mptsas_t *mpt)
 {
@@ -2656,19 +2957,21 @@
 	caddr_t			memp;
 	ddi_dma_cookie_t	cookie;
 	size_t			mem_size;
+	mptsas_reply_pqueue_t	*rpqp;
+	int			i;
 
 	/*
 	 * re-alloc when it has already alloced
 	 */
-	mptsas_dma_addr_destroy(&mpt->m_dma_post_queue_hdl,
-	    &mpt->m_acc_post_queue_hdl);
+	mptsas_free_post_queue(mpt);
 
 	/*
 	 * The reply descriptor post queue size is:
 	 *   Reply Descriptor Post Queue Depth * 8
 	 * The "8" is the size of each descriptor (8 bytes or 64 bits).
 	 */
-	mem_size = mpt->m_post_queue_depth * 8;
+	mpt->m_post_reply_qcount = mpt->m_intr_cnt;
+	mem_size = mpt->m_post_queue_depth * 8 * mpt->m_post_reply_qcount;
 
 	/*
 	 * set the DMA attributes.  The Reply Descriptor Post Queue must be
@@ -2679,7 +2982,12 @@
 	frame_dma_attrs.dma_attr_sgllen = 1;
 
 	/*
-	 * allocate the reply post queue
+	 * Allocate the reply post queue(s).
+	 * MPI2.5 introduces a method to allocate multiple queues
+	 * using a redirect table. For now stick to one contiguous
+	 * chunck. This can get as big as 1Mbyte for 16 queues.
+	 * The spec gives no indication that the queue size can be
+	 * reduced if you have many of them.
 	 */
 	if (mptsas_dma_addr_create(mpt, frame_dma_attrs,
 	    &mpt->m_dma_post_queue_hdl, &mpt->m_acc_post_queue_hdl, &memp,
@@ -2695,11 +3003,24 @@
 	mpt->m_post_queue_dma_addr = cookie.dmac_laddress;
 	mpt->m_post_queue = memp;
 
+	mpt->m_rep_post_queues = kmem_zalloc(sizeof (mptsas_reply_pqueue_t) *
+	    mpt->m_post_reply_qcount, KM_SLEEP);
+	rpqp = mpt->m_rep_post_queues;
+	for (i = 0; i < mpt->m_post_reply_qcount; i++) {
+		rpqp->rpq_queue = memp;
+		mutex_init(&rpqp->rpq_mutex, NULL, MUTEX_DRIVER, NULL);
+		rpqp->rpq_dlist.dl_tail = &rpqp->rpq_dlist.dl_q;
+		rpqp->rpq_num = (uint8_t)i;
+		memp += (mpt->m_post_queue_depth * 8);
+		rpqp++;
+	}
+
 	/*
 	 * Clear the reply post queue memory.
 	 */
 	bzero(mpt->m_post_queue, mem_size);
 
+	mpt->m_dma_flags |= MPTSAS_POST_QUEUE;
 	return (DDI_SUCCESS);
 }
 
@@ -2709,6 +3030,9 @@
 	if (mpt->m_replyh_args == NULL) {
 		mpt->m_replyh_args = kmem_zalloc(sizeof (m_replyh_arg_t) *
 		    mpt->m_max_replies, KM_SLEEP);
+	} else {
+		bzero(mpt->m_replyh_args, sizeof (m_replyh_arg_t) *
+		    mpt->m_max_replies);
 	}
 }
 
@@ -2751,17 +3075,28 @@
 	/*
 	 * Free up any allocated memory
 	 */
-	mptsas_dma_addr_destroy(&mpt->m_dma_req_frame_hdl,
-	    &mpt->m_acc_req_frame_hdl);
+	if (mpt->m_dma_flags & MPTSAS_REQ_FRAME) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_req_frame_hdl,
+		    &mpt->m_acc_req_frame_hdl);
+	}
+
+	if (mpt->m_dma_flags & MPTSAS_REQ_SENSE) {
+		rmfreemap(mpt->m_erqsense_map);
+		mptsas_dma_addr_destroy(&mpt->m_dma_req_sense_hdl,
+		    &mpt->m_acc_req_sense_hdl);
+	}
 
-	mptsas_dma_addr_destroy(&mpt->m_dma_reply_frame_hdl,
-	    &mpt->m_acc_reply_frame_hdl);
+	if (mpt->m_dma_flags & MPTSAS_REPLY_FRAME) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_reply_frame_hdl,
+		    &mpt->m_acc_reply_frame_hdl);
+	}
 
-	mptsas_dma_addr_destroy(&mpt->m_dma_free_queue_hdl,
-	    &mpt->m_acc_free_queue_hdl);
+	if (mpt->m_dma_flags & MPTSAS_FREE_QUEUE) {
+		mptsas_dma_addr_destroy(&mpt->m_dma_free_queue_hdl,
+		    &mpt->m_acc_free_queue_hdl);
+	}
 
-	mptsas_dma_addr_destroy(&mpt->m_dma_post_queue_hdl,
-	    &mpt->m_acc_post_queue_hdl);
+	mptsas_free_post_queue(mpt);
 
 	if (mpt->m_replyh_args != NULL) {
 		kmem_free(mpt->m_replyh_args, sizeof (m_replyh_arg_t)
@@ -3040,8 +3375,10 @@
 #endif
 	mptsas_t	*mpt = PKT2MPT(pkt);
 	mptsas_cmd_t	*cmd = PKT2CMD(pkt);
-	int		rval;
+	int		rval, start;
+	uint8_t		pref;
 	mptsas_target_t	*ptgt = cmd->cmd_tgt_addr;
+	mptsas_tx_waitqueue_t *txwq;
 
 	NDBG1(("mptsas_scsi_start: pkt=0x%p", (void *)pkt));
 	ASSERT(ptgt);
@@ -3090,114 +3427,82 @@
 	 * we enable this feature only when the helper threads are enabled,
 	 * at which we think the loads are heavy.
 	 *
-	 * per instance mutex m_tx_waitq_mutex is introduced to protect the
-	 * m_tx_waitqtail, m_tx_waitq, m_tx_draining.
+	 * per instance, per queue mutex m_tx_waitq[i].txwq_mutex is
+	 * introduced to protect the txwq_qtail, txwq_cmdq, txwq_len
 	 */
 
-	if (mpt->m_doneq_thread_n) {
-		if (mutex_tryenter(&mpt->m_mutex) != 0) {
-			rval = mptsas_accept_txwq_and_pkt(mpt, cmd);
-			mutex_exit(&mpt->m_mutex);
-		} else if (cmd->cmd_pkt_flags & FLAG_NOINTR) {
-			mutex_enter(&mpt->m_mutex);
-			rval = mptsas_accept_txwq_and_pkt(mpt, cmd);
-			mutex_exit(&mpt->m_mutex);
-		} else {
-			mutex_enter(&mpt->m_tx_waitq_mutex);
-			/*
-			 * ptgt->m_dr_flag is protected by m_mutex or
-			 * m_tx_waitq_mutex. In this case, m_tx_waitq_mutex
-			 * is acquired.
-			 */
-			if (ptgt->m_dr_flag == MPTSAS_DR_INTRANSITION) {
-				if (cmd->cmd_pkt_flags & FLAG_NOQUEUE) {
-					/*
-					 * The command should be allowed to
-					 * retry by returning TRAN_BUSY to
-					 * to stall the I/O's which come from
-					 * scsi_vhci since the device/path is
-					 * in unstable state now.
-					 */
-					mutex_exit(&mpt->m_tx_waitq_mutex);
-					return (TRAN_BUSY);
-				} else {
-					/*
-					 * The device is offline, just fail the
-					 * command by returning
-					 * TRAN_FATAL_ERROR.
-					 */
-					mutex_exit(&mpt->m_tx_waitq_mutex);
-					return (TRAN_FATAL_ERROR);
+	if (mpt->m_txwq_enabled == TRUE) {
+		int gotmtx = 0;
+
+		if (mpt->m_txwq_allow_q_jumping) {
+			gotmtx = mutex_tryenter(&mpt->m_mutex);
+		}
+		if (gotmtx == 0) {
+			/* We didn't get the mutex or didn't try */
+			if (cmd->cmd_pkt_flags & FLAG_NOINTR) {
+				mutex_enter(&mpt->m_mutex);
+				/* Polled commands queue jump */
+				mptsas_accept_tx_waitqs(mpt);
+			} else {
+				rval = mptsas_check_targ_intxtion(
+				    cmd->cmd_tgt_addr,
+				    cmd->cmd_pkt_flags);
+				if (rval != TRAN_ACCEPT) {
+					return (rval);
 				}
-			}
-			if (mpt->m_tx_draining) {
+
 				cmd->cmd_flags |= CFLAG_TXQ;
-				*mpt->m_tx_waitqtail = cmd;
-				mpt->m_tx_waitqtail = &cmd->cmd_linkp;
-				mutex_exit(&mpt->m_tx_waitq_mutex);
-			} else { /* drain the queue */
-				mpt->m_tx_draining = 1;
-				mutex_exit(&mpt->m_tx_waitq_mutex);
-				mutex_enter(&mpt->m_mutex);
-				rval = mptsas_accept_txwq_and_pkt(mpt, cmd);
-				mutex_exit(&mpt->m_mutex);
+				pref = mpt->m_pref_tx_waitq;
+				txwq = &mpt->m_tx_waitq[pref];
+
+				if (mutex_tryenter(&txwq->txwq_mutex) == 0) {
+					txwq = &mpt->m_tx_waitq[pref^1];
+					mutex_enter(&txwq->txwq_mutex);
+				} else {
+					pref ^= 1;
+					mpt->m_pref_tx_waitq = pref;
+				}
+
+				*txwq->txwq_qtail = cmd;
+				txwq->txwq_qtail = &cmd->cmd_linkp;
+				txwq->txwq_len++;
+				if (!txwq->txwq_draining) {
+					cv_signal(&txwq->txwq_cv);
+				}
+				mutex_exit(&txwq->txwq_mutex);
+				return (rval);
 			}
 		}
 	} else {
 		mutex_enter(&mpt->m_mutex);
-		/*
-		 * ptgt->m_dr_flag is protected by m_mutex or m_tx_waitq_mutex
-		 * in this case, m_mutex is acquired.
-		 */
-		if (ptgt->m_dr_flag == MPTSAS_DR_INTRANSITION) {
-			if (cmd->cmd_pkt_flags & FLAG_NOQUEUE) {
-				/*
-				 * commands should be allowed to retry by
-				 * returning TRAN_BUSY to stall the I/O's
-				 * which come from scsi_vhci since the device/
-				 * path is in unstable state now.
-				 */
-				mutex_exit(&mpt->m_mutex);
-				return (TRAN_BUSY);
-			} else {
-				/*
-				 * The device is offline, just fail the
-				 * command by returning TRAN_FATAL_ERROR.
-				 */
-				mutex_exit(&mpt->m_mutex);
-				return (TRAN_FATAL_ERROR);
-			}
-		}
-		rval = mptsas_accept_pkt(mpt, cmd);
+	}
+	rval = mptsas_check_targ_intxtion(cmd->cmd_tgt_addr,
+	    cmd->cmd_pkt_flags);
+	if (rval != TRAN_ACCEPT) {
 		mutex_exit(&mpt->m_mutex);
+		return (rval);
+	}
+
+	start = mptsas_accept_pkt(mpt, cmd, &rval);
+	mutex_exit(&mpt->m_mutex);
+	if (start) {
+		(void) mptsas_start_cmd(mpt, cmd);
 	}
 
 	return (rval);
 }
 
-/*
- * Accept all the queued cmds(if any) before accept the current one.
- */
 static int
-mptsas_accept_txwq_and_pkt(mptsas_t *mpt, mptsas_cmd_t *cmd)
+mptsas_check_targ_intxtion(mptsas_target_t *ptgt, int cmd_pkt_flags)
 {
-	int rval;
-	mptsas_target_t	*ptgt = cmd->cmd_tgt_addr;
-
-	ASSERT(mutex_owned(&mpt->m_mutex));
 	/*
-	 * The call to mptsas_accept_tx_waitq() must always be performed
-	 * because that is where mpt->m_tx_draining is cleared.
-	 */
-	mutex_enter(&mpt->m_tx_waitq_mutex);
-	mptsas_accept_tx_waitq(mpt);
-	mutex_exit(&mpt->m_tx_waitq_mutex);
-	/*
-	 * ptgt->m_dr_flag is protected by m_mutex or m_tx_waitq_mutex
-	 * in this case, m_mutex is acquired.
+	 * ptgt->m_dr_flag is a variable that is only ever changed by
+	 * direct write under the main m_mutex.
+	 * It doesn't need a mutex hold to protect this read.
 	 */
+
 	if (ptgt->m_dr_flag == MPTSAS_DR_INTRANSITION) {
-		if (cmd->cmd_pkt_flags & FLAG_NOQUEUE) {
+		if (cmd_pkt_flags & FLAG_NOQUEUE) {
 			/*
 			 * The command should be allowed to retry by returning
 			 * TRAN_BUSY to stall the I/O's which come from
@@ -3213,13 +3518,48 @@
 			return (TRAN_FATAL_ERROR);
 		}
 	}
-	rval = mptsas_accept_pkt(mpt, cmd);
+	return (TRAN_ACCEPT);
+}
 
-	return (rval);
+/*
+ * Note that this function has a side effect of releasing the
+ * per target mutex.
+ */
+static void
+mptsas_offline_target_direct(mptsas_t *mpt, mptsas_target_t *ptgt)
+{
+	char				phy_mask_name[MPTSAS_MAX_PHYS];
+	mptsas_phymask_t		phymask = ptgt->m_addr.mta_phymask;
+	dev_info_t			*parent;
+
+	ASSERT(mutex_owned(&mpt->m_mutex));
+
+	ptgt->m_dr_flag = MPTSAS_DR_INTRANSITION;
+	bzero(phy_mask_name, MPTSAS_MAX_PHYS);
+	(void) sprintf(phy_mask_name, "%x", phymask);
+	parent = scsi_hba_iport_find(mpt->m_dip, phy_mask_name);
+
+	if (parent != NULL) {
+		mptsas_offline_target(mpt, ptgt,
+		    ptgt->m_deviceinfo & DEVINFO_DIRECT_ATTACHED ?
+		    MPTSAS_TOPO_FLAG_DIRECT_ATTACHED_DEVICE :
+		    MPTSAS_TOPO_FLAG_EXPANDER_ATTACHED_DEVICE,
+		    parent);
+	} else {
+		mptsas_log(mpt, CE_WARN, "Failed to find an "
+		    "iport for \"%s\", should not happen!",
+		    phy_mask_name);
+	}
 }
 
+/*
+ * In order to be efficient with the m_mutex (which can be dropped before
+ * calling mptsas_start_cmd()) indicate if start_cmd should be called via the
+ * returned value (FALSE or TRUE). Caller is then responsible for doing the
+ * right thing with the m_mutex.
+ */
 static int
-mptsas_accept_pkt(mptsas_t *mpt, mptsas_cmd_t *cmd)
+mptsas_accept_pkt(mptsas_t *mpt, mptsas_cmd_t *cmd, int *tran_rval)
 {
 	int		rval = TRAN_ACCEPT;
 	mptsas_target_t	*ptgt = cmd->cmd_tgt_addr;
@@ -3232,20 +3572,26 @@
 		rval = mptsas_prepare_pkt(cmd);
 		if (rval != TRAN_ACCEPT) {
 			cmd->cmd_flags &= ~CFLAG_TRANFLAG;
-			return (rval);
+			goto set_tranrval;
 		}
 	}
 
 	/*
-	 * reset the throttle if we were draining
+	 * If the command came from the tx wait q it may have slipped
+	 * by the check for dr_flag before being added to the queue.
+	 * Fail here with abort status.
 	 */
-	if ((ptgt->m_t_ncmds == 0) &&
-	    (ptgt->m_t_throttle == DRAIN_THROTTLE)) {
-		NDBG23(("reset throttle"));
-		ASSERT(ptgt->m_reset_delay == 0);
-		mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
+	if (cmd->cmd_flags & CFLAG_TXQ) {
+		rval = mptsas_check_targ_intxtion(cmd->cmd_tgt_addr,
+		    cmd->cmd_pkt_flags);
+		if (rval != TRAN_ACCEPT) {
+			mptsas_set_pkt_reason(mpt, cmd, CMD_ABORTED,
+			    STAT_ABORTED);
+			mptsas_doneq_add(mpt, cmd);
+			mptsas_doneq_empty(mpt);
+			goto set_tranrval;
+		}
 	}
-
 	/*
 	 * If HBA is being reset, the DevHandles are being re-initialized,
 	 * which means that they could be invalid even if the target is still
@@ -3258,30 +3604,42 @@
 		if (cmd->cmd_flags & CFLAG_TXQ) {
 			mptsas_doneq_add(mpt, cmd);
 			mptsas_doneq_empty(mpt);
-			return (rval);
 		} else {
-			return (TRAN_BUSY);
+			rval = TRAN_BUSY;
 		}
+		goto set_tranrval;
+	}
+
+	mutex_enter(&ptgt->m_t_mutex);
+	/*
+	 * reset the throttle if we were draining
+	 */
+	if ((ptgt->m_t_ncmds == 0) &&
+	    (ptgt->m_t_throttle == DRAIN_THROTTLE)) {
+		NDBG23(("reset throttle"));
+		ASSERT(ptgt->m_reset_delay == 0);
+		mptsas_set_throttle(mpt, ptgt, MAX_THROTTLE);
 	}
 
 	/*
 	 * If device handle has already been invalidated, just
-	 * fail the command. In theory, command from scsi_vhci
-	 * client is impossible send down command with invalid
+	 * fail the command. In theory, for a command from scsi_vhci
+	 * client it's impossible to receive a command with an invalid
 	 * devhdl since devhdl is set after path offline, target
-	 * driver is not suppose to select a offlined path.
+	 * driver is not supposed to select an offlined path.
 	 */
 	if (ptgt->m_devhdl == MPTSAS_INVALID_DEVHDL) {
-		NDBG20(("rejecting command, it might because invalid devhdl "
+		NDBG3(("rejecting command, it might because invalid devhdl "
 		    "request."));
+		mutex_exit(&ptgt->m_t_mutex);
 		mptsas_set_pkt_reason(mpt, cmd, CMD_DEV_GONE, STAT_TERMINATED);
 		if (cmd->cmd_flags & CFLAG_TXQ) {
 			mptsas_doneq_add(mpt, cmd);
 			mptsas_doneq_empty(mpt);
-			return (rval);
 		} else {
-			return (TRAN_FATAL_ERROR);
+			rval = TRAN_FATAL_ERROR;
 		}
+		goto set_tranrval;
 	}
 	/*
 	 * The first case is the normal case.  mpt gets a command from the
@@ -3292,15 +3650,22 @@
 	if ((mpt->m_ncmds <= (mpt->m_max_requests - 2)) &&
 	    (ptgt->m_t_throttle > HOLD_THROTTLE) &&
 	    (ptgt->m_t_ncmds < ptgt->m_t_throttle) &&
-	    (ptgt->m_reset_delay == 0) &&
+	    (ptgt->m_reset_delay == 0) && (mpt->m_polled_intr == 0) &&
 	    (ptgt->m_t_nwait == 0) &&
 	    ((cmd->cmd_pkt_flags & FLAG_NOINTR) == 0)) {
-		if (mptsas_save_cmd(mpt, cmd) == TRUE) {
-			(void) mptsas_start_cmd(mpt, cmd);
+		ASSERT((cmd->cmd_flags & CFLAG_CMDIOC) == 0);
+		if (mptsas_save_cmd_to_slot(mpt, cmd) == TRUE) {
+			ptgt->m_t_ncmds++;
+			mutex_exit(&ptgt->m_t_mutex);
+			cmd->cmd_active_expiration = 0;
+			*tran_rval = rval;
+			return (TRUE);
 		} else {
+			mutex_exit(&ptgt->m_t_mutex);
 			mptsas_waitq_add(mpt, cmd);
 		}
 	} else {
+		mutex_exit(&ptgt->m_t_mutex);
 		/*
 		 * Add this pkt to the work queue
 		 */
@@ -3319,17 +3684,36 @@
 			}
 		}
 	}
-	return (rval);
+set_tranrval:
+	*tran_rval = rval;
+	return (FALSE);
 }
 
-int
-mptsas_save_cmd(mptsas_t *mpt, mptsas_cmd_t *cmd)
+static void
+mptsas_retry_pkt(mptsas_t *mpt, mptsas_cmd_t *cmd)
 {
-	mptsas_slots_t *slots = mpt->m_active;
-	uint_t slot, start_rotor;
-	mptsas_target_t *ptgt = cmd->cmd_tgt_addr;
+	int		rval;
 
-	ASSERT(MUTEX_HELD(&mpt->m_mutex));
+	cmd->cmd_pkt_flags |= FLAG_HEAD;
+	cmd->cmd_flags |= CFLAG_RETRY;
+	cmd->cmd_flags &= ~CFLAG_TXQ;
+	if (mptsas_accept_pkt(mpt, cmd, &rval)) {
+		(void) mptsas_start_cmd(mpt, cmd);
+	}
+
+	/*
+	 * If there was a problem clear the retry flag so that the
+	 * command will be completed with error rather than get lost!
+	 */
+	if (rval != TRAN_ACCEPT)
+		cmd->cmd_flags &= ~CFLAG_RETRY;
+}
+
+static int
+mptsas_save_cmd_to_slot(mptsas_t *mpt, mptsas_cmd_t *cmd)
+{
+	mptsas_slots_t *slots = mpt->m_active;
+	uint_t slot, start_rotor, rotor, n_normal;
 
 	/*
 	 * Account for reserved TM request slot and reserved SMID of 0.
@@ -3344,15 +3728,17 @@
 	 * the normal slot after the one we select, unless we select the last
 	 * normal slot in which case it returns to slot 1.
 	 */
-	start_rotor = slots->m_rotor;
+	start_rotor = rotor = slots->m_rotor;
+	n_normal = slots->m_n_normal;
 	do {
-		slot = slots->m_rotor++;
-		if (slots->m_rotor > slots->m_n_normal)
-			slots->m_rotor = 1;
+		slot = rotor++;
+		if (rotor > n_normal)
+			rotor = 1;
 
-		if (slots->m_rotor == start_rotor)
+		if (rotor == start_rotor)
 			break;
 	} while (slots->m_slot[slot] != NULL);
+	slots->m_rotor = rotor;
 
 	if (slots->m_slot[slot] != NULL)
 		return (FALSE);
@@ -3361,25 +3747,51 @@
 
 	cmd->cmd_slot = slot;
 	slots->m_slot[slot] = cmd;
-	mpt->m_ncmds++;
+	atomic_inc_32(&mpt->m_ncmds);
 
 	/*
-	 * only increment per target ncmds if this is not a
-	 * command that has no target associated with it (i.e. a
-	 * event acknoledgment)
+	 * Distribute the commands amongst the reply queues (Interrupt vectors).
+	 * Stick to 0 for polled.
 	 */
-	if ((cmd->cmd_flags & CFLAG_CMDIOC) == 0) {
-		ptgt->m_t_ncmds++;
+	if (!(cmd->cmd_pkt_flags & FLAG_NOINTR) &&
+	    !(cmd->cmd_flags & (CFLAG_PASSTHRU|CFLAG_CONFIG|CFLAG_FW_DIAG)) &&
+	    (mpt->m_post_reply_qcount > 1)) {
+		cmd->cmd_rpqidx = slot % mpt->m_post_reply_qcount;
+	}
+	atomic_inc_32(&mpt->m_rep_post_queues[cmd->cmd_rpqidx].rpq_ncmds);
+	return (TRUE);
+}
+
+int
+mptsas_save_cmd(mptsas_t *mpt, mptsas_cmd_t *cmd)
+{
+	mptsas_target_t *ptgt = cmd->cmd_tgt_addr;
+
+	ASSERT(MUTEX_HELD(&mpt->m_mutex));
+
+	if (!mptsas_save_cmd_to_slot(mpt, cmd)) {
+		return (FALSE);
 	}
-	cmd->cmd_active_timeout = cmd->cmd_pkt->pkt_time;
 
 	/*
-	 * If initial timout is less than or equal to one tick, bump
-	 * the timeout by a tick so that command doesn't timeout before
-	 * its allotted time.
+	 * only increment per target ncmds if this is not a
+	 * command that has no target associated with it (i.e. a
+	 * event acknoledgement)
 	 */
-	if (cmd->cmd_active_timeout <= mptsas_scsi_watchdog_tick) {
-		cmd->cmd_active_timeout += mptsas_scsi_watchdog_tick;
+	if ((cmd->cmd_flags & CFLAG_CMDIOC) == 0) {
+		/*
+		 * Expiration time is set in mptsas_start_cmd
+		 */
+		mutex_enter(&ptgt->m_t_mutex);
+		ptgt->m_t_ncmds++;
+		mutex_exit(&ptgt->m_t_mutex);
+		cmd->cmd_active_expiration = 0;
+	} else {
+		/*
+		 * Initialize expiration time for passthrough commands,
+		 */
+		cmd->cmd_active_expiration = gethrtime() +
+		    (hrtime_t)cmd->cmd_pkt->pkt_time * NANOSEC;
 	}
 	return (TRUE);
 }
@@ -3484,22 +3896,13 @@
 	 */
 	if (pkt == NULL) {
 		ddi_dma_handle_t	save_dma_handle;
-		ddi_dma_handle_t	save_arq_dma_handle;
-		struct buf		*save_arq_bp;
-		ddi_dma_cookie_t	save_arqcookie;
 
 		cmd = kmem_cache_alloc(mpt->m_kmem_cache, kf);
 
 		if (cmd) {
 			save_dma_handle = cmd->cmd_dmahandle;
-			save_arq_dma_handle = cmd->cmd_arqhandle;
-			save_arq_bp = cmd->cmd_arq_buf;
-			save_arqcookie = cmd->cmd_arqcookie;
 			bzero(cmd, sizeof (*cmd) + scsi_pkt_size());
 			cmd->cmd_dmahandle = save_dma_handle;
-			cmd->cmd_arqhandle = save_arq_dma_handle;
-			cmd->cmd_arq_buf = save_arq_bp;
-			cmd->cmd_arqcookie = save_arqcookie;
 
 			pkt = (void *)((uchar_t *)cmd +
 			    sizeof (struct mptsas_cmd));
@@ -3779,7 +4182,8 @@
 		 * If there is only one window, the resid will be 0
 		 */
 		pkt->pkt_resid = (bp->b_bcount - cmd->cmd_totaldmacount);
-		NDBG16(("mptsas_dmaget: cmd_dmacount=%d.", cmd->cmd_dmacount));
+		NDBG3(("mptsas_scsi_init_pkt: cmd_dmacount=%d.",
+		    cmd->cmd_dmacount));
 	}
 	return (pkt);
 }
@@ -3832,19 +4236,12 @@
 {
 	mptsas_cmd_t		*cmd = buf;
 	mptsas_t		*mpt  = cdrarg;
-	struct scsi_address	ap;
-	uint_t			cookiec;
-	ddi_dma_attr_t		arq_dma_attr;
 	int			(*callback)(caddr_t);
 
 	callback = (kmflags == KM_SLEEP)? DDI_DMA_SLEEP: DDI_DMA_DONTWAIT;
 
 	NDBG4(("mptsas_kmem_cache_constructor"));
 
-	ap.a_hba_tran = mpt->m_tran;
-	ap.a_target = 0;
-	ap.a_lun = 0;
-
 	/*
 	 * allocate a dma handle
 	 */
@@ -3853,41 +4250,6 @@
 		cmd->cmd_dmahandle = NULL;
 		return (-1);
 	}
-
-	cmd->cmd_arq_buf = scsi_alloc_consistent_buf(&ap, (struct buf *)NULL,
-	    SENSE_LENGTH, B_READ, callback, NULL);
-	if (cmd->cmd_arq_buf == NULL) {
-		ddi_dma_free_handle(&cmd->cmd_dmahandle);
-		cmd->cmd_dmahandle = NULL;
-		return (-1);
-	}
-
-	/*
-	 * allocate a arq handle
-	 */
-	arq_dma_attr = mpt->m_msg_dma_attr;
-	arq_dma_attr.dma_attr_sgllen = 1;
-	if ((ddi_dma_alloc_handle(mpt->m_dip, &arq_dma_attr, callback,
-	    NULL, &cmd->cmd_arqhandle)) != DDI_SUCCESS) {
-		ddi_dma_free_handle(&cmd->cmd_dmahandle);
-		scsi_free_consistent_buf(cmd->cmd_arq_buf);
-		cmd->cmd_dmahandle = NULL;
-		cmd->cmd_arqhandle = NULL;
-		return (-1);
-	}
-
-	if (ddi_dma_buf_bind_handle(cmd->cmd_arqhandle,
-	    cmd->cmd_arq_buf, (DDI_DMA_READ | DDI_DMA_CONSISTENT),
-	    callback, NULL, &cmd->cmd_arqcookie, &cookiec) != DDI_SUCCESS) {
-		ddi_dma_free_handle(&cmd->cmd_dmahandle);
-		ddi_dma_free_handle(&cmd->cmd_arqhandle);
-		scsi_free_consistent_buf(cmd->cmd_arq_buf);
-		cmd->cmd_dmahandle = NULL;
-		cmd->cmd_arqhandle = NULL;
-		cmd->cmd_arq_buf = NULL;
-		return (-1);
-	}
-
 	return (0);
 }
 
@@ -3901,15 +4263,6 @@
 
 	NDBG4(("mptsas_kmem_cache_destructor"));
 
-	if (cmd->cmd_arqhandle) {
-		(void) ddi_dma_unbind_handle(cmd->cmd_arqhandle);
-		ddi_dma_free_handle(&cmd->cmd_arqhandle);
-		cmd->cmd_arqhandle = NULL;
-	}
-	if (cmd->cmd_arq_buf) {
-		scsi_free_consistent_buf(cmd->cmd_arq_buf);
-		cmd->cmd_arq_buf = NULL;
-	}
 	if (cmd->cmd_dmahandle) {
 		ddi_dma_free_handle(&cmd->cmd_dmahandle);
 		cmd->cmd_dmahandle = NULL;
@@ -3967,7 +4320,7 @@
 	 * address to dma to and from the driver.  The second
 	 * address is the address mpt uses to fill in the SGL.
 	 */
-	p->m_phys_addr = cookie.dmac_address;
+	p->m_phys_addr = cookie.dmac_laddress;
 
 	return (DDI_SUCCESS);
 }
@@ -4002,12 +4355,7 @@
     int cmdlen, int tgtlen, int statuslen, int kf)
 {
 	caddr_t			cdbp, scbp, tgt;
-	int			(*callback)(caddr_t) = (kf == KM_SLEEP) ?
-	    DDI_DMA_SLEEP : DDI_DMA_DONTWAIT;
-	struct scsi_address	ap;
 	size_t			senselength;
-	ddi_dma_attr_t		ext_arq_dma_attr;
-	uint_t			cookiec;
 
 	NDBG3(("mptsas_pkt_alloc_extern: "
 	    "cmd=0x%p cmdlen=%d tgtlen=%d statuslen=%d kf=%x",
@@ -4042,38 +4390,20 @@
 
 		senselength = statuslen - MPTSAS_GET_ITEM_OFF(
 		    struct scsi_arq_status, sts_sensedata);
-		cmd->cmd_rqslen = (uchar_t)senselength;
-
-		ap.a_hba_tran = mpt->m_tran;
-		ap.a_target = 0;
-		ap.a_lun = 0;
-
-		cmd->cmd_ext_arq_buf = scsi_alloc_consistent_buf(&ap,
-		    (struct buf *)NULL, senselength, B_READ,
-		    callback, NULL);
-
-		if (cmd->cmd_ext_arq_buf == NULL) {
-			goto fail;
-		}
-		/*
-		 * allocate a extern arq handle and bind the buf
-		 */
-		ext_arq_dma_attr = mpt->m_msg_dma_attr;
-		ext_arq_dma_attr.dma_attr_sgllen = 1;
-		if ((ddi_dma_alloc_handle(mpt->m_dip,
-		    &ext_arq_dma_attr, callback,
-		    NULL, &cmd->cmd_ext_arqhandle)) != DDI_SUCCESS) {
-			goto fail;
-		}
-
-		if (ddi_dma_buf_bind_handle(cmd->cmd_ext_arqhandle,
-		    cmd->cmd_ext_arq_buf, (DDI_DMA_READ | DDI_DMA_CONSISTENT),
-		    callback, NULL, &cmd->cmd_ext_arqcookie,
-		    &cookiec)
-		    != DDI_SUCCESS) {
-			goto fail;
+		if (senselength > mpt->m_req_sense_size) {
+			unsigned long i;
+			cmd->cmd_extrqslen = (uint16_t)senselength;
+			cmd->cmd_extrqschunks = (senselength +
+			    (mpt->m_req_sense_size - 1))/mpt->m_req_sense_size;
+			i = rmalloc_wait(mpt->m_erqsense_map,
+			    cmd->cmd_extrqschunks);
+			ASSERT(i != 0);
+			cmd->cmd_extrqsidx = i - 1;
+			cmd->cmd_arq_buf = mpt->m_extreq_sense +
+			    (cmd->cmd_extrqsidx * mpt->m_req_sense_size);
+		} else {
+			cmd->cmd_rqslen = (uchar_t)senselength;
 		}
-		cmd->cmd_flags |= CFLAG_EXTARQBUFVALID;
 	}
 	return (0);
 fail:
@@ -4095,20 +4425,15 @@
 		_NOTE(NOT_REACHED)
 		/* NOTREACHED */
 	}
+	if (cmd->cmd_extrqslen != 0) {
+		rmfree(mpt->m_erqsense_map, cmd->cmd_extrqschunks,
+		    cmd->cmd_extrqsidx + 1);
+	}
 	if (cmd->cmd_flags & CFLAG_CDBEXTERN) {
 		kmem_free(cmd->cmd_pkt->pkt_cdbp, (size_t)cmd->cmd_cdblen);
 	}
 	if (cmd->cmd_flags & CFLAG_SCBEXTERN) {
 		kmem_free(cmd->cmd_pkt->pkt_scbp, (size_t)cmd->cmd_scblen);
-		if (cmd->cmd_flags & CFLAG_EXTARQBUFVALID) {
-			(void) ddi_dma_unbind_handle(cmd->cmd_ext_arqhandle);
-		}
-		if (cmd->cmd_ext_arqhandle) {
-			ddi_dma_free_handle(&cmd->cmd_ext_arqhandle);
-			cmd->cmd_ext_arqhandle = NULL;
-		}
-		if (cmd->cmd_ext_arq_buf)
-			scsi_free_consistent_buf(cmd->cmd_ext_arq_buf);
 	}
 	if (cmd->cmd_flags & CFLAG_PRIVEXTERN) {
 		kmem_free(cmd->cmd_pkt->pkt_private, (size_t)cmd->cmd_privlen);
@@ -4154,11 +4479,6 @@
 		cmd->cmd_flags &= ~CFLAG_DMAVALID;
 	}
 
-	if (cmd->cmd_flags & CFLAG_EXTARQBUFVALID) {
-		(void) ddi_dma_unbind_handle(cmd->cmd_ext_arqhandle);
-		cmd->cmd_flags &= ~CFLAG_EXTARQBUFVALID;
-	}
-
 	mptsas_free_extra_sgl_frame(mpt, cmd);
 }
 
